## secvarctl 1.1.0

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright 2023 IBM Corp.

cmake_minimum_required( VERSION 3.12 )
project( secvarctl C )

add_executable( secvarctl )

target_sources( secvarctl PRIVATE secvarctl.c generic.c )

target_include_directories( secvarctl BEFORE PRIVATE
  ./
  include/
  external/libstb-secvar/
  external/libstb-secvar/include/
  external/libstb-secvar/include/secvar/
  external/libstb-secvar/external/
)

# Extract version string from VERSION
file( STRINGS VERSION VERSION_DATA REGEX "=[0-9\-]*$")
list( TRANSFORM VERSION_DATA STRIP )
list( TRANSFORM VERSION_DATA REPLACE "([^=]+)=(.*)" "set(\\1 \"\\2\")\n" )
cmake_language(EVAL CODE ${VERSION_DATA})
set( SECVARCTL_VERSION "${SECVARCTL_VERSION_MAJOR}.${SECVARCTL_VERSION_MINOR}.${SECVARCTL_VERSION_PATCH}${SECVARCTL_VERSION_EXTRA}")

message( STATUS "Detected version string as ${SECVARCTL_VERSION}" )

target_compile_definitions( secvarctl PRIVATE
  SECVAR_CRYPTO_WRITE_FUNC
  SECVARCTL_VERSION=\"${SECVARCTL_VERSION}\"
)

# Backend selection
option( HOST_BACKEND "Build with the host backend enabled" ON )
option( GUEST_BACKEND "Build with the guest backend enabled" ON )

if( HOST_BACKEND )
  include( backends/host/CMakeLists.txt )
endif()
if( GUEST_BACKEND )
  include( backends/guest/CMakeLists.txt )
endif()
if( NOT ( HOST_BACKEND OR GUEST_BACKEND) )
  message( FATAL_ERROR "No backends are enabled, refusing to build." )
endif()

# Crypto library selection
set( CRYPTO "openssl" CACHE STRING "Crypto library to use" )
set_property( CACHE CRYPTO PROPERTY STRINGS openssl mbedtls gnutls )
get_property( CRYPTO_STRINGS CACHE CRYPTO PROPERTY STRINGS )
if (NOT CRYPTO IN_LIST CRYPTO_STRINGS)
  message(FATAL_ERROR "CRYPTO must be set to one of: ${CRYPTO_STRINGS}")
endif()
message( STATUS "Using ${CRYPTO} for crypto")

if( CRYPTO STREQUAL openssl )
  target_compile_definitions( secvarctl PRIVATE SECVAR_CRYPTO_OPENSSL )
  find_package( OpenSSL REQUIRED )
  target_link_libraries( secvarctl OpenSSL::SSL )
endif()
if( CRYPTO STREQUAL mbedtls )
  target_include_directories( secvarctl AFTER PRIVATE external/extraMbedtls/include/ )
  target_sources( secvarctl PRIVATE
    external/extraMbedtls/pkcs7.c
    external/extraMbedtls/pkcs7_write.c
    external/skiboot/libstb/secvar/crypto/crypto-mbedtls.c
  )
  target_compile_definitions( secvarctl PRIVATE SECVAR_CRYPTO_MBEDTLS )
  find_library( MBEDX509 mbedx509 HINTS ENV PATH REQUIRED )
  find_library( MBEDCRYPTO mbedcrypto HINTS ENV PATH REQUIRED )
  find_library( MBEDTLS mbedtls HINTS ENV PATH REQUIRED )
  target_link_libraries( secvarctl ${MBEDTLS} ${MBEDX509} ${MBEDCRYPTO} ${PTHREAD} )
endif()
if( CRYPTO STREQUAL gnutls )
  message( FATAL_ERROR "gnutls is not currently supported for cmake builds" )
endif()

add_subdirectory( external/libstb-secvar )
target_link_libraries( secvarctl stb-secvar-openssl )

set( DEBUG_FLAGS "-O0 -g3 -Wall -Werror" )
set( COVERAGE_FLAGS "-fprofile-arcs -ftest-coverage" )
set( SANITIZE_FLAGS
  "-fsanitize=address"
  "-fsanitize=undefined"
  "-fno-sanitize-recover=all"
  "-fsanitize=float-divide-by-zero"
  "-fsanitize=float-cast-overflow"
  "-fno-sanitize=null"
  "-fno-sanitize=alignment"
)

set( CMAKE_CONFIGURATION_TYPES "Debug" "Release" )
set( DEFAULT_BUILD_TYPE "Debug" )
if ( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE ${DEFAULT_BUILD_TYPE} )
    message( "Setting build type to default: " ${CMAKE_BUILD_TYPE} )
endif(  )
set( CMAKE_C_FLAGS_RELEASE "-O2 -g" )
set( CMAKE_C_FLAGS_DEBUG   "${DEBUG_FLAGS} ${COVERAGE_FLAGS}" )

option( USE_ASAN "Build with address sanitizers" OFF )
if( USE_ASAN )
  target_compile_options( secvarctl PRIVATE ${SANITIZE_FLAGS} )
  target_link_options( secvarctl PRIVATE ${SANITIZE_FLAGS} )
endif(  )

install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/secvarctl.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1 )
install( TARGETS secvarctl DESTINATION bin )

=== Makefile ===
# SPDX-License-Identifier: BSD-2-Clause
# Copyright 2023 IBM Corp.

CC = gcc
AR = ar
LD = gcc
_CFLAGS = -Wall -Werror -MMD -ggdb3 -fPIC
CFLAGS =
LDFLAGS =

SRC_DIR = ./src
OBJ_DIR = ./obj
LIB_DIR = ./lib
TEST_DIR = ./test

INCLUDE = -I./include -I./ -I./external

DEBUG ?= 0
ifeq ($(strip $(DEBUG)), 1)
  _CFLAGS += -g
else
  _LDFLAGS += -s
endif

# Handle coverage generator preference, only supports lcov/gcovr via the Makefile
#  consider using the `make coverage` target and manually running your if not supported
ifeq ($(strip $(PREFER_LCOV)), 1)
  COVERER = lcov
else ifeq ($(strip $(PREFER_GCOVR)), 1)
  COVERER = gcovr
else
  # Default to preferring gcovr if it exists, fallback to lcov if not
  ifneq ($(strip $(shell which gcovr)),)
    COVERER = gcovr
  else ifneq ($(strip $(shell which lcov)),)
    COVERER = lcov
  else
  endif
endif

SRCS = esl.c \
       authentication_2.c \
       update.c \
       pseries.c \
       crypto_util.c \
       log.c \
       phyp.c

#By default, build with openssl as crypto library
CRYPTO_LIB = openssl
CRYPTO_LIB_OPTIONS = openssl

ifeq ($(filter $(CRYPTO_LIB),$(CRYPTO_LIB_OPTIONS)),)
  $(error CRYPTO_LIB must be set to one of: $(CRYPTO_LIB_OPTIONS))
endif

ifeq ($(CRYPTO_LIB), openssl)
  SRCS += crypto_openssl.c
  CRYPTO_ARG = OPENSSL=1
  _CFLAGS += -DSECVAR_CRYPTO_OPENSSL
endif

SRCS := $(addprefix $(SRC_DIR)/,$(SRCS))

OBJS = $(patsubst $(SRC_DIR)/%.c,$(OBJ_DIR)/%.o,$(SRCS))
COV_OBJS = $(patsubst $(SRC_DIR)/%.c,$(OBJ_DIR)/%.gcov.o,$(SRCS))
_CFLAGS += $(CFLAGS) $(INCLUDE)
_LDFLAGS += $(LDFLAGS)

all: $(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).a $(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).so

-include $(OBJS:.o=.d)

$(OBJ_DIR)/%.o: $(SRC_DIR)/%.c
	@mkdir -p $(OBJ_DIR)
	$(CC) $(_CFLAGS) $< -o $@ -c

# Coverage objects
$(OBJ_DIR)/%.gcov.o: $(SRC_DIR)/%.c
	@mkdir -p $(OBJ_DIR)
	$(CC) $(_CFLAGS) -Wall -Werror -g -O0 --coverage -DNO_PRLOG $< -o $@ -c

$(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).a: $(OBJS)
	@mkdir -p $(LIB_DIR)
	$(AR) -rcs $@ $^ $(_LDFLAGS)

$(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).gcov.a: $(COV_OBJS)
	@mkdir -p $(LIB_DIR)
	$(AR) -rcs $@ $^ $(_LDFLAGS)

$(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).so: $(OBJS)
	@mkdir -p $(LIB_DIR)
	$(LD) $(_LDFLAGS) -shared $^ -o $@

tests: $(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).a
	@$(MAKE) -C $(TEST_DIR) $(CRYPTO_ARG)

check: $(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).a
	@$(MAKE) -C $(TEST_DIR) $(CRYPTO_ARG) check

memcheck: $(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).a
	@$(MAKE) -C $(TEST_DIR) memcheck

coverage: $(LIB_DIR)/libstb-secvar-$(CRYPTO_LIB).gcov.a
	@$(MAKE) -C $(TEST_DIR) coverage

coverage-report: coverage
ifeq ($(COVERER),)
	$(error Neither lcov nor gcovr appear to be installed, please install one of them to use this target)
endif
ifeq ($(PERSIST_REPORT),)
	rm -rf report
endif
	@mkdir -p report

ifeq ($(COVERER),lcov)
	@echo "Using lcov to generate report"
	@lcov --no-external --capture --directory . --output-file report/test.info
	@genhtml report/test.info --legend --output-directory=report
else ifeq ($(COVERER),gcovr)
	@echo "Using gcovr to generate report"
	@gcovr --html-details report/index.html --delete
endif

TEST_SRCS = $(wildcard test/*.c)
# variableScope: avoid reducing variable scope to maintain C compatibility
# missingInclude: TODO: ideally rework all includes to make this unnecessary
# unusedFunction: not all functions provided in the library might be used
#  TODO: should be removed when test coverage improves
CPPCHECK_ARGS = --enable=all --force            \
                --suppress=variableScope        \
                --suppress=missingInclude       \
                --suppress=unusedFunction       \
                --error-exitcode=1 -q
cppcheck:
	cppcheck $(CPPCHECK_ARGS)                    \
             -D__BYTE_ORDER__=__LITTLE_ENDIAN__  \
             $(INCLUDE) $(SRCS) $(TEST_SRCS)

cppcheck-be:
	cppcheck $(CPPCHECK_ARGS)                \
             -D__BYTE_ORDER__=__BIG_ENDIAN__ \
             $(INCLUDE) $(SRCS) $(TEST_SRCS)

clean:
	@$(MAKE) -C $(TEST_DIR) clean
	rm -rf $(OBJ_DIR) $(LIB_DIR)
	rm -rf report/

.PHONY: all check cppcheck cppcheck-be clean tests coverage coverage-report

=== guest/Makefile ===
CC = gcc
_CFLAGS += -Wall -Werror -MMD -ggdb3 -fPIC
CFLAGS =
LDFLAGS =

LIB_DIR=./lib
COMMON_SRC_DIR = ./common
GUEST_EXTERNAL_BACKEND_DIR = ../../external/guest/libstb-secvar
GUEST_EXTERNAL_BACKEND = ../../external/guest

INCLUDES = -I../../include \
           -I$(GUEST_EXTERNAL_BACKEND_DIR)/include \
           -I$(GUEST_EXTERNAL_BACKEND_DIR)/include/secvar \
           -I$(GUEST_EXTERNAL_BACKEND_DIR) \
           -I./include

DEBUG ?= 0
ifeq ($(strip $(DEBUG)), 1)
  _CFLAGS += -g
else
  _LDFLAGS += -s
endif

#use CRYPTO_READ_ONLY for smaller executable but limited functionality
#removes all write functions (secvarctl generate, pem_to_der etc.)
CRYPTO_READ_ONLY = 0
ifeq ($(strip $(CRYPTO_READ_ONLY)), 0)
  _CFLAGS += -DSECVAR_CRYPTO_WRITE_FUNC
endif

DYNAMIC_LIB = 0
STATIC_LIB = 1
ifeq ($(strip $(DYNAMIC_LIB)), 1)
  LD = gcc
  STATIC_LIB = 0
else
  LD = ar -rcs
  STATIC_LIB = 1
endif

_CFLAGS += $(CFLAGS) $(INCLUDES)

_LDFLAGS = $(LDFLAGS) -lcrypto -lstb-secvar-openssl -L$(LIB_DIR)

SRCS = $(COMMON_SRC_DIR)/util.c \
       $(COMMON_SRC_DIR)/write.c \
       $(COMMON_SRC_DIR)/verify.c \
       $(COMMON_SRC_DIR)/validate.c \
       $(COMMON_SRC_DIR)/read.c \
       $(COMMON_SRC_DIR)/generate.c \
       ./guest_svc_write.c \
       ./guest_svc_verify.c \
       ./guest_svc_validate.c \
			 ./guest_svc_read.c \
			 ./guest_svc_generate.c

GUEST_OBJS = $(SRCS:.c=.o)

ifeq ($(LIB_DIR), ./lib)
  LIB_DIRS = ../../../backends/guest/lib
else
  LIB_DIRS = ../$(LIB_DIR)
endif

all: libstb-secvar libguest-backend-openssl

%.o: %.c
	$(CC) $(_CFLAGS) $< -o $@ -c

libguest-backend-openssl: $(GUEST_OBJS)
ifeq ($(strip $(DYNAMIC_LIB)), 1)
	$(LD) $(_LDFLAGS) -shared $^ -o $(LIB_DIR)/$@.so
else
	$(LD) $(LIB_DIR)/$@.a $^
endif
	@echo "Guest Backend Build successful!"

libstb-secvar:
	@mkdir -p $(LIB_DIR)
	@$(MAKE) -C $(GUEST_EXTERNAL_BACKEND_DIR) LIB_DIR=$(LIB_DIRS) STATIC_LIB=$(STATIC_LIB) \
	            CRYPTO_READ_ONLY=$(CRYPTO_READ_ONLY)

clean:
	@$(MAKE) -C $(GUEST_EXTERNAL_BACKEND_DIR) clean
	find $(COMMON_SRC_DIR) -name "*.[od]" -delete
	find . -name "*.[od]" -delete
	rm -rf $(LIB_DIR)

.PHONY: all libguest-backend-openssl libstb-secvar clean

=== host/CMakeLists.txt ===
set ( BACKEND_HOST_SRCS
  host_svc_generate.c
  host_svc_read.c
  host_svc_validate.c
  host_svc_verify.c
  host_svc_write.c
)

target_include_directories ( secvarctl AFTER PRIVATE
  external/skiboot/
  external/skiboot/libstb/
  external/skiboot/include/
  backends/host/
)

list ( TRANSFORM BACKEND_HOST_SRCS PREPEND ${CMAKE_CURRENT_LIST_DIR}/ )

target_sources ( secvarctl PRIVATE ${BACKEND_HOST_SRCS} )

# External dependencies
target_sources ( secvarctl PRIVATE
  external/skiboot/libstb/secvar/secvar_util.c
  external/skiboot/libstb/secvar/backend/edk2-compat.c
  external/skiboot/libstb/secvar/backend/edk2-compat-process.c
)

target_compile_definitions ( secvarctl PRIVATE SECVAR_HOST_BACKEND )

=== debian/changelog ===
secvarctl (1.1.0-0ubuntu1) plucky; urgency=low
 
  * Initial release v1.1.0 (LP: #2064345)

 -- Patricia Domingues <patricia.domingues@canonical.com>  Wed, 12 Feb 2025 18:11:09 -0300

=== debian/control ===
Source: secvarctl
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: 
 cmake, 
 debhelper-compat (= 13),
 gnutls-bin,
 libssl-dev,
 python3,
Standards-Version: 4.7.0
Homepage: https://github.com/open-power/secvarctl

Package: secvarctl
Architecture: ppc64el amd64                                                                            
Depends: 
 ${shlibs:Depends},
 ${misc:Depends},
Description: To manipulate and generate Secure Boot variables on POWER
 x86 works for file generation and validation.
 Suite of tools to manipulate and generate Secure Boot variables on POWER.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ # make

override_dh_install:
	rm -f debian/tmp/usr/share/doc/secvarctl/copyright

=== debian/watch ===
version=4                                                                                                                                                     
https://github.com/open-power/secvarctl/tags .*/v?(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
